; Assembly Source File
; Created 09/10/2003, 22:16:51
	include		"doorsos.h"	        	;Bibliothque Kernel avec ROM_CALLS
	include		"polysnd2.h"		      	;Librairie PolySnd v2.0
		
	xdef		_ti89				;Compile pour TI89
	xdef		_ti92plus			;Compile pour TI92+
	xdef		_main			        ;Entre du programme
	xdef		_comment		        ;Commentaire du programe
	
_main: 
 	move.w	#$0700,d0			        ;Dsactive toutes les interruptions
	trap	#1					
	move.l	$64,int1			        ;Sauvegarde l'adresse de l'auto int n1
	move.l	$68,int2			        ;Sauvegarde l'adresse de l'auto int n2
	move.l	#empty_handler,$40064			;Inhibe auto int n1
	move.l	#empty_handler2,$40068			;Inhibe auto int n2
	moveq.w	#0,d0					
	trap	#1				        ;Active toutes les interruptions
	
 	bsr	GetCalculator			   	;Renvoie le model de TI dans calc
 
 	jsr	polysnd2::EnableSound		        ;Active le port I/O en mode son
	jsr	polysnd2::InstallSound		        ;Install PolySnd
 
	move.w  #120,d0                     
        jsr     polysnd2::SetTempo_voice1

        move.b  #_MONO,d0
        jsr     polysnd2::PlayMode

        move.w  #440,d0
        move.b  #240,d0
        jsr     polysnd2::SetBeep_voice1

        move.b  #_VOICE1,d0
        jsr     polysnd2::SetState

;-----------------------------------------------------
;Fonction qui attend l'appuye d'une touche 
;-----------------------------------------------------
loop_key:                                               ;Boucle clavier
        jsr     polysnd2::GetState
        cmp.b   #_VOICE1,d0
        bne     fin					
        
        cmp.b	#0,calc	   			        ;Si TI89
	beq	key_89			               	;key_89
	bne	key_92			               	;key_92 focntionne aussi sur V200

key_89: 
	move.w	#6,d0					;Repre ESC
	bsr	masque
	btst.b	#0,d0
	beq	fin			                ;Si press fin
	bne	loop_key			        ;Sinon loop

key_92: 
	move.w	#8,d0				        ;Repr ESC
	bsr	masque	
	btst.b	#6,d0
	beq	fin			         	;Si press fin
	bra	loop_key			        ;sinon loop
 
fin:	
 	jsr	polysnd2::UninstallSound      		;Dsinstall PolySnd
	jsr	polysnd2::DisableSound	                ;Remet le port I/O  son tat par dfaut.
	
	move.w	#$0700,d0			      	;Dsactive interruptions
	trap	#1
	move.l	int1(PC),$40064			        ;Remet  son tat courant l'auto int 1
	move.l	int2(PC),$40068			        ;Remet  son tat courant l'auto int 2
	moveq	#0,d0					
	trap	#1				        ;Active interruptions
 	rts	


;Interruption vide, l'auto int n1 ne sera pas execut
empty_handler:
	rte

;Dsactive l'auto int n2	
empty_handler2:
	sf.b $60001b 				        ;Permet d'inhiber l'interruption clavier du TIOS
	rte 
			
;----------------------------
;Detection de la calculatrice
;----------------------------
GetCalculator:
	move.l	a1,-(a7)			        ;Sauvegarde a1
	move.l  $C8,a0				        ;Addresse pour vrifier si TI-89 ou TI-92 Plus
	move.b	#1,calc			                ;Prdfinis comme TI-92 Plus
	move.l	a0,d1				        ;Prpare d1
	and.l   #$400000,d1			        ;Si ~0 alors TI-92 Plus sinon TI-89 ou V200
	bne	__calculator		                ;Dans cas TI-92 Plus alors Fin
	move.b	#0,calc				        ;Prdfinis comme TI-89
	move.l  $2F*4(a0),a1		                ;Prpare condition
	cmp.b	#200,2(a1)			        ;Si 200 alors TI-89
	bcs	__calculator		                ;Donc Fin
	move.b	#2,calc		                        ;Donc V200
__calculator:
	move.l	(a7)+,a1		                ;Restaure a1
	rts
	
	
;--------------------------------------------
;Masque pour la lecture du clavier	
;********************************************
;********************************************
;masque une ligne du clavier
;--------------------------------------------
;d0=ligne -> d0=rponse
;********************************************
masque:
	move.l	d1,-(a7)
	move.w	#$FFFE,d1
	rol.w	d0,d1
	clr.w	d0
	move.w	d1,($600018)
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	move.b	($60001B),d0
	move.l	(a7)+,d1
	rts

;------------------
;Variables
;------------------
int1	dc.l	0		;Ancienne auto int n1
int2	dc.l	0		;Ancienne auto int n2

calc	 dc.b	0		;Model de la calculatrice

;Commentaire du programme
_comment dc.b	"Example 1",0
	end
